#ifndef PUI_IO_H
#define PUI_IO_H

#include "pi-dlp.h"
/*
 * pui_io.h
 *
 * Copyright (c) 1996, Scotter <scotter@iname.com>
 *
 * This is free software, licensed under the GNU Public License V2.
 *
 */

/*
 * Actual access to record structure and data routines
 * should be kept "private." See pui.h for "public" routines.
 */

/*
 * pui_version_record unnecessary-- it's just a string
 */

/*
 * pui_dbinfo_record unnecessary-- see DBInfo structure
 */

struct pui_global_record {
  unsigned long lock;
  unsigned long num_records;
  unsigned long head;
  unsigned long tail;
};

struct pui_header_record {
  unsigned long lock;
  unsigned char attr;
  unsigned char category;
  unsigned long prev;
  unsigned long next;
};

struct pui_data_record {
  unsigned long length;
  char *data;
};

int pui_version_read  (const PUI_FILE db, char **buf);
int pui_version_write (const PUI_FILE db, char **buf);
int pui_version_exists(const PUI_FILE db);
int pui_version_delete(const PUI_FILE db);

int pui_dbinfo_read  (const PUI_FILE db, struct DBInfo *info);
int pui_dbinfo_write (const PUI_FILE db, const struct DBInfo *info);
int pui_dbinfo_exists(const PUI_FILE db);
int pui_dbinfo_delete(const PUI_FILE db);

int pui_global_read  (const PUI_FILE db, struct pui_global_record *r);
int pui_global_write (const PUI_FILE db, const struct pui_global_record *r);
int pui_global_exists(const PUI_FILE db);
int pui_global_delete(const PUI_FILE db);

int pui_header_read  (const PUI_FILE db,
                      const unsigned long id,
                      struct pui_header_record *r);
int pui_header_write (const PUI_FILE db,
                      const unsigned long id,
                      const struct pui_header_record *r);
int pui_header_exists(const PUI_FILE db, const unsigned long id);
int pui_header_delete(const PUI_FILE db, const unsigned long id);

int pui_record_read  (const PUI_FILE db,
                      const unsigned long id,
                      struct pui_data_record *r);
int pui_record_write (const PUI_FILE db,
                      const unsigned long id,
                      const struct pui_data_record *r);
int pui_record_exists(const PUI_FILE db, const unsigned long id);
int pui_record_delete(const PUI_FILE db, const unsigned long id);

int pui_appinfo_read  (const PUI_FILE db, struct pui_data_record *r);
int pui_appinfo_write (const PUI_FILE db, const struct pui_data_record *r);
int pui_appinfo_exists(const PUI_FILE db);
int pui_appinfo_delete(const PUI_FILE db);

#endif
