/*
 * tclDBInfo.c
 *
 * Copyright (c) 1996, Scotter <scotter@iname.com>
 *
 * This is free software, licensed under the GNU Public License V2.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tcl.h"
#include "pi-dlp.h" /* For DBInfo structure */
#include "pui.h"
#include "tclpui.h"

/*---------------------DBInfo-----------------------*/

void tclDBInfo_Read(Tcl_Interp *interp, char *varname, PUI_FILE puidb)
{
  char s[16];
  struct DBInfo info;

  pui_ReadDBInfo(puidb, &info);

  sprintf(s, "%d", info.flags);
  Tcl_SetVar2(interp, varname, "flags", s, 0);
  sprintf(s, "%d", info.version);
  Tcl_SetVar2(interp, varname, "version", s, 0);

  sprintf(s, "%ld", info.crdate);
  Tcl_SetVar2(interp, varname, "crdate", s, 0);
  sprintf(s, "%ld", info.moddate);
  Tcl_SetVar2(interp, varname, "moddate", s, 0);
  sprintf(s, "%ld", info.backupdate);
  Tcl_SetVar2(interp, varname, "backupdate", s, 0);

  sprintf(s, "%ld", info.modnum);
  Tcl_SetVar2(interp, varname, "modnum", s, 0);
  sprintf(s, "0x%lx", info.type);
  Tcl_SetVar2(interp, varname, "type", s, 0);
  sprintf(s, "0x%lx", info.creator);
  Tcl_SetVar2(interp, varname, "creator", s, 0);

  Tcl_SetVar2(interp, varname, "name", info.name, 0);
}

void tclDBInfo_Write(Tcl_Interp *interp, char *varname, PUI_FILE puidb)
{
  struct DBInfo info;
  char *value;

  value = Tcl_GetVar2(interp, varname, "flags", 0);
  info.flags = SAFEATOI(value);
  value = Tcl_GetVar2(interp, varname, "version", 0);
  info.version = SAFEATOI(value);

  value = Tcl_GetVar2(interp, varname, "crdate", 0);
  info.crdate = SAFESTRTOUL(value, 10);
  value = Tcl_GetVar2(interp, varname, "moddate", 0);
  info.moddate = SAFESTRTOUL(value, 10);
  value = Tcl_GetVar2(interp, varname, "backupdate", 0);
  info.backupdate = SAFESTRTOUL(value, 10);

  value = Tcl_GetVar2(interp, varname, "modnum", 0);
  info.modnum = SAFESTRTOUL(value, 10);
  value = Tcl_GetVar2(interp, varname, "type", 0);
  info.type = SAFESTRTOUL(value, 16);
  value = Tcl_GetVar2(interp, varname, "creator", 0);
  info.creator = SAFESTRTOUL(value, 16);

  value = Tcl_GetVar2(interp, varname, "name", 0);
  strncpy(info.name, value, 32);

  info.more = 0;
  info.index = 0;

  pui_WriteDBInfo(puidb, &info);
}

