/*
 * tclpui.h
 *
 * Copyright (c) 1996, Scotter <scotter@iname.com>
 *
 * This is free software, licensed under the GNU Public License V2.
 */
#ifndef TCLPUI_H
#define TCLPUI_H

#include <stdlib.h>
#include <string.h>
#include "tcl.h"
#include "pi-dlp.h" /* For DBInfo structure */
#include "pui.h"

static char nullstring[] = "";
#define SAFE(a) (a?a:nullstring)
#define SAFEATOI(a) ((a)?atoi(a):0)
#define SAFESTRTOUL(a,b) ((a)?strtoul((a),0,(b)):0)
#define SAFESTRINGCOPY(s,v) if (v) { strncpy((s),(v),16); } else { (s)[0] = 0; }

/*
 * This is an "object" to encapsulate each database type.
 * There are five "member functions" that handle
 * conversion of that databases data into and out of
 * tcl variable arrays.
 *
 */
struct tclDBModule {
  char *name;
  void (*NewDBInfo)();    /* Function to set default DBInfo for database */
  void (*Read)();         /* Function to read record into a tcl array */
  void (*Write)();        /* Function to write record from tcl array */
  void (*AppInfoRead)();  /* Function to read AppInfo into a tcl array */
  void (*AppInfoWrite)(); /* Function to write AppInfo from a tcl array */
};
/*
 * I didn't prototype the above functions. Please send me
 * e-mail (scotter@iname.com) if your compiler requires the prototypes.
 */

extern void tclDBInfo_Read(Tcl_Interp *, char *, PUI_FILE);
extern void tclDBInfo_Write(Tcl_Interp *, char *, PUI_FILE);


#endif
